Incorporate changes for version 1.1.0

This commit is contained in:
2026-02-25 14:05:59 -05:00
parent b2402566a5
commit 6c9c0e3dcf
15 changed files with 869 additions and 205 deletions

384
LICENSE Normal file
View File

@@ -0,0 +1,384 @@
The following license applies to all OpenLog code
Copyright (C) 2016 by Rod Wright :
GNU GENERAL PUBLIC LICENSE
Version 2, June 1991
Copyright (C) 1989, 1991 Free Software Foundation, Inc.
59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.
Preamble
The licenses for most software are designed to take away your
freedom to share and change it. By contrast, the GNU General Public
License is intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users. This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it. (Some other Free Software Foundation software is covered by
the GNU Library General Public License instead.) You can apply it to
your programs, too.
When we speak of free software, we are referring to freedom, not
price. Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it
in new free programs; and that you know you can do these things.
To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.
For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have. You must make sure that they, too, receive or can get the
source code. And you must show them these terms so they know their
rights.
We protect your rights with two steps: (1) copyright the software, and
(2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.
Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software. If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.
Finally, any free program is threatened constantly by software
patents. We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary. To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.
The precise terms and conditions for copying, distribution and
modification follow.
GNU GENERAL PUBLIC LICENSE
TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
0. This License applies to any program or other work which contains
a notice placed by the copyright holder saying it may be distributed
under the terms of this General Public License. The \"Program\", below,
refers to any such program or work, and a \"work based on the Program\"
means either the Program or any derivative work under copyright law:
that is to say, a work containing the Program or a portion of it,
either verbatim or with modifications and/or translated into another
language. (Hereinafter, translation is included without limitation in
the term \"modification\".) Each licensee is addressed as \"you\".
Activities other than copying, distribution and modification are not
covered by this License; they are outside its scope. The act of
running the Program is not restricted, and the output from the Program
is covered only if its contents constitute a work based on the
Program (independent of having been made by running the Program).
Whether that is true depends on what the Program does.
1. You may copy and distribute verbatim copies of the Program's
source code as you receive it, in any medium, provided that you
conspicuously and appropriately publish on each copy an appropriate
copyright notice and disclaimer of warranty; keep intact all the
notices that refer to this License and to the absence of any warranty;
and give any other recipients of the Program a copy of this License
along with the Program.
You may charge a fee for the physical act of transferring a copy, and
you may at your option offer warranty protection in exchange for a fee.
2. You may modify your copy or copies of the Program or any portion
of it, thus forming a work based on the Program, and copy and
distribute such modifications or work under the terms of Section 1
above, provided that you also meet all of these conditions:
a) You must cause the modified files to carry prominent notices
stating that you changed the files and the date of any change.
b) You must cause any work that you distribute or publish, that in
whole or in part contains or is derived from the Program or any
part thereof, to be licensed as a whole at no charge to all third
parties under the terms of this License.
c) If the modified program normally reads commands interactively
when run, you must cause it, when started running for such
interactive use in the most ordinary way, to print or display an
announcement including an appropriate copyright notice and a
notice that there is no warranty (or else, saying that you provide
a warranty) and that users may redistribute the program under
these conditions, and telling the user how to view a copy of this
License. (Exception: if the Program itself is interactive but
does not normally print such an announcement, your work based on
the Program is not required to print an announcement.)
These requirements apply to the modified work as a whole. If
identifiable sections of that work are not derived from the Program,
and can be reasonably considered independent and separate works in
themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works. But when you
distribute the same sections as part of a whole which is a work based
on the Program, the distribution of the whole must be on the terms of
this License, whose permissions for other licensees extend to the
entire whole, and thus to each and every part regardless of who wrote it.
Thus, it is not the intent of this section to claim rights or contest
your rights to work written entirely by you; rather, the intent is to
exercise the right to control the distribution of derivative or
collective works based on the Program.
In addition, mere aggregation of another work not based on the Program
with the Program (or with a work based on the Program) on a volume of
a storage or distribution medium does not bring the other work under
the scope of this License.
3. You may copy and distribute the Program (or a work based on it,
under Section 2) in object code or executable form under the terms of
Sections 1 and 2 above provided that you also do one of the following:
a) Accompany it with the complete corresponding machine-readable
source code, which must be distributed under the terms of Sections
1 and 2 above on a medium customarily used for software interchange; or,
b) Accompany it with a written offer, valid for at least three
years, to give any third party, for a charge no more than your
cost of physically performing source distribution, a complete
machine-readable copy of the corresponding source code, to be
distributed under the terms of Sections 1 and 2 above on a medium
customarily used for software interchange; or,
c) Accompany it with the information you received as to the offer
to distribute corresponding source code. (This alternative is
allowed only for noncommercial distribution and only if you
received the program in object code or executable form with such
an offer, in accord with Subsection b above.)
The source code for a work means the preferred form of the work for
making modifications to it. For an executable work, complete source
code means all the source code for all modules it contains, plus any
associated interface definition files, plus the scripts used to
control compilation and installation of the executable. However, as a
special exception, the source code distributed need not include
anything that is normally distributed (in either source or binary
form) with the major components (compiler, kernel, and so on) of the
operating system on which the executable runs, unless that component
itself accompanies the executable.
If distribution of executable or object code is made by offering
access to copy from a designated place, then offering equivalent
access to copy the source code from the same place counts as
distribution of the source code, even though third parties are not
compelled to copy the source along with the object code.
4. You may not copy, modify, sublicense, or distribute the Program
except as expressly provided under this License. Any attempt
otherwise to copy, modify, sublicense or distribute the Program is
void, and will automatically terminate your rights under this License.
However, parties who have received copies, or rights, from you under
this License will not have their licenses terminated so long as such
parties remain in full compliance.
5. You are not required to accept this License, since you have not
signed it. However, nothing else grants you permission to modify or
distribute the Program or its derivative works. These actions are
prohibited by law if you do not accept this License. Therefore, by
modifying or distributing the Program (or any work based on the
Program), you indicate your acceptance of this License to do so, and
all its terms and conditions for copying, distributing or modifying
the Program or works based on it.
6. Each time you redistribute the Program (or any work based on the
Program), the recipient automatically receives a license from the
original licensor to copy, distribute or modify the Program subject to
these terms and conditions. You may not impose any further
restrictions on the recipients' exercise of the rights granted herein.
You are not responsible for enforcing compliance by third parties to
this License.
7. If, as a consequence of a court judgment or allegation of patent
infringement or for any other reason (not limited to patent issues),
conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License. If you cannot
distribute so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you
may not distribute the Program at all. For example, if a patent
license would not permit royalty-free redistribution of the Program by
all those who receive copies directly or indirectly through you, then
the only way you could satisfy both it and this License would be to
refrain entirely from distribution of the Program.
If any portion of this section is held invalid or unenforceable under
any particular circumstance, the balance of the section is intended to
apply and the section as a whole is intended to apply in other
circumstances.
It is not the purpose of this section to induce you to infringe any
patents or other property right claims or to contest validity of any
such claims; this section has the sole purpose of protecting the
integrity of the free software distribution system, which is
implemented by public license practices. Many people have made
generous contributions to the wide range of software distributed
through that system in reliance on consistent application of that
system; it is up to the author/donor to decide if he or she is willing
to distribute software through any other system and a licensee cannot
impose that choice.
This section is intended to make thoroughly clear what is believed to
be a consequence of the rest of this License.
8. If the distribution and/or use of the Program is restricted in
certain countries either by patents or by copyrighted interfaces, the
original copyright holder who places the Program under this License
may add an explicit geographical distribution limitation excluding
those countries, so that distribution is permitted only in or among
countries not thus excluded. In such case, this License incorporates
the limitation as if written in the body of this License.
9. The Free Software Foundation may publish revised and/or new versions
of the General Public License from time to time. Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.
Each version is given a distinguishing version number. If the Program
specifies a version number of this License which applies to it and \"any
later version\", you have the option of following the terms and conditions
either of that version or of any later version published by the Free
Software Foundation. If the Program does not specify a version number of
this License, you may choose any version ever published by the Free Software
Foundation.
10. If you wish to incorporate parts of the Program into other free
programs whose distribution conditions are different, write to the author
to ask for permission. For software which is copyrighted by the Free
Software Foundation, write to the Free Software Foundation; we sometimes
make exceptions for this. Our decision will be guided by the two goals
of preserving the free status of all derivatives of our free software and
of promoting the sharing and reuse of software generally.
NO WARRANTY
11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM \"AS IS\" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.
12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.
END OF TERMS AND CONDITIONS
How to Apply These Terms to Your New Programs
If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.
To do so, attach the following notices to the program. It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the \"copyright\" line and a pointer to where the full notice is found.
<one line to give the program's name and a brief idea of what it does.>
Copyright (C) <year> <name of author>
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
Also add information on how to contact you by electronic and paper mail.
If the program is interactive, make it output a short notice like this
when it starts in an interactive mode:
Gnomovision version 69, Copyright (C) year name of author
Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
This is free software, and you are welcome to redistribute it
under certain conditions; type `show c' for details.
The hypothetical commands `show w' and `show c' should show the appropriate
parts of the General Public License. Of course, the commands you use may
be called something other than `show w' and `show c'; they could even be
mouse-clicks or menu items--whatever suits your program.
You should also get your employer (if you work as a programmer) or your
school, if any, to sign a \"copyright disclaimer\" for the program, if
necessary. Here is a sample; alter the names:
Yoyodyne, Inc., hereby disclaims all copyright interest in the program
`Gnomovision' (which makes passes at compilers) written by James Hacker.
<signature of Ty Coon>, 1 April 1989
Ty Coon, President of Vice
This General Public License does not permit incorporating your program into
proprietary programs. If your program is a subroutine library, you may
consider it more useful to permit linking proprietary applications with the
library. If this is what you want to do, use the GNU Library General
Public License instead of this License.
The following license applies to jquery code :
Copyright jQuery Foundation and other contributors, https://jquery.org/
This software consists of voluntary contributions made by many
individuals. For exact contribution history, see the revision history
available at https://github.com/jquery/jquery-ui
The following license applies to all parts of this software except as
documented below:
====
Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:
The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
====
Copyright and related rights for sample code are waived via CC0. Sample
code is defined as all source code contained within the demos directory.
CC0: http://creativecommons.org/publicdomain/zero/1.0/

View File

@@ -1 +1 @@
1.0.2 1.1.0

View File

@@ -1,7 +0,0 @@
Package: * >
Pin: release o=LP-PPA-mozillateam
Pin-Priority: 1001
Package: firefox
Pin: version 1:1snap1-0ubuntu2
Pin-Priority: -1

View File

@@ -8,7 +8,16 @@
DEBUG="0" DEBUG="0"
# URL to load for the kiosk browser. # URL to load for the kiosk browser.
TGT_URL="https://localhost:10000" # This can be a website, specified like:
# http://somesite.com/somepage
# or a local file, specified like:
# file:/home/kioskuser/somefile.pdf
# If the URL ends with ".pdf", it will be opened using xpdf, otherwise
# it will be assumed to be of some format that can be displayed by a
# web browser.
# You can also use the word "test" which will cause OpenKiosk to
# start an xterm, which is useful for development and testing.
TGT_URL="test"
# Interval in seconds to poll the URL for changes. # Interval in seconds to poll the URL for changes.
# This should be enabled where the kiosk is used as a display for a file # This should be enabled where the kiosk is used as a display for a file
@@ -31,15 +40,3 @@ DSP_OFF_SEC="1800"
# Values are one of "normal", "left", "right", or "inverted". # Values are one of "normal", "left", "right", or "inverted".
ROTATION="normal" ROTATION="normal"
# For standard kiosk functionality
APP_CMD="firefox -private --kiosk $TGT_URL"
ALIVE_STRING="firefox"
KILL_CMD="killall firefox"
CLEANUP_CMD="/usr/local/bin/kiosk_cleanup.sh"
#-----------------------------------------------------------------------
# For test use
#APP_CMD="xterm"
#ALIVE_STRING="xterm"
#KILL_CMD="killall xterm"
#CLEANUP_CMD="sleep 1"

View File

@@ -1,45 +0,0 @@
# openkiosk.conf
#
# Configuration file for OpenKiosk
# Debug flag. Set to 1 to cause startkiosk.sh to output helpful
# information to ~/startkiosk.log.
# Set to 0 for production use, or the log could fill up your filesystem!
DEBUG="0"
# URL to load for the kiosk browser.
TGT_URL="https://localhost:10000"
# Interval in seconds to poll the URL for changes.
# This should be enabled where the kiosk is used as a display for a file
# fetched from a URL. Do not use for an interactive kiosk.
# Set to 0 to disable polling or for an interactive kiosk.
POLL_INTERVAL="0"
# Display blanking is controlled by DPMS. For a display-only kiosk,
# set INHIBIT_BLANK to "1" to prevent screen blanking, ignoring the
# DSP parameters. If INHIBIT_BLANK is set to "0", the DSP parameters
# control the number of seconds for standby, suspend, and off modes.
# If you find that your display is going to sleep and not waking up, try
# setting the OFF and/or SUSP parameters to 0 which will disable them.
INHIBIT_BLANK="0"
DSP_STBY_SEC="600"
DSP_SUSP_SEC="1200"
DSP_OFF_SEC="1800"
# Display rotation. Can be used to control the orientation of the display.
# Values are one of "normal", "left", "right", or "inverted".
ROTATION="normal"
# For standard kiosk functionality
APP_CMD="chromium-browser --test-type --ignore-certificate-errors --kiosk --no-first-run --check-for-update-interval=1 --simulate-upgrade --incognito $TGT_URL"
ALIVE_STRING="chromium-browse"
KILL_CMD="killall chromium-browser"
CLEANUP_CMD="/usr/local/bin/kiosk_cleanup.sh"
#-----------------------------------------------------------------------
# For test use
#APP_CMD="xterm"
#ALIVE_STRING="xterm"
#KILL_CMD="killall xterm"
#CLEANUP_CMD="sleep 1"

View File

@@ -190,7 +190,7 @@
<!-- allow alt-F4 to kill browser --> <!-- allow alt-F4 to kill browser -->
<keybind key="A-F4"> <keybind key="A-F4">
<action name="Execute"> <action name="Execute">
<command>pkill firefox;pkill chromium-browser</command> <command>pkill chromium</command>
</action> </action>
</keybind> </keybind>
<!-- browser disable opening new window --> <!-- browser disable opening new window -->

View File

@@ -0,0 +1,64 @@
<html>
<head>
<meta http-equiv=\"x-ua-compatible\" content=\"IE=edge\">
<title>OpenKiosk</title>
</head>
<body>
<h3 align="center">
OpenKiosk
</h3><br>
<table border="0" width="100%">
<tr>
<td align="center">Current version is <b>1.1.0</b></td>
</tr>
</table>
<br>
<p>
<b>Welcome</b><br>
Welcome to OpenKiosk. You are seeing this page because you have accepted the default URL during installation.
Obviously this is not very useful. To make it more useful, you'll need to edit the /etc/openkiosk.conf file
and adjust things for your needs.
</p>
<p>
<b>Configuration</b><br>
To edit this file, you'll either need to ssh into the kiosk machine or use
webmin. If you elected to install webmin during OpenKiosk installation, you can
<a href="https://localhost:10000"> click here </a> to access it, then use the
File Manager tool to navigate to /etc and edit the openkiosk.conf file.
The file contains descriptions of the available options.
<br>
For testing purposes, you can set the TGT_URL parameter in the openkiosk.conf file
to "test". This will give you an xterm window on the desktop.
<br>
Any changes made to the configuration file will be automatically detected and the
the kiosk will reload using the new configuration.
</p>
<p>
<b>Useful Key Combinations</b><br>
Many of the normal key combinations have been disabled to prevent misuse of the kiosk. However, there are two that
you should know about.
<br>
Pressing &lt;alt&gt;-&lt;F4&gt; will kill and restart the display app, reloading the target URL.
<br>
Pressing &lt;ctrl&gt;-&lt;alt&gt;-&lt;shift&gt;-&lt;del&gt; will shut down the kiosk.
<br>
Pressing &lt;ctrl&gt;-&lt;alt&gt;-&lt;shift&gt;-&lt;ins&gt; will reboot the kiosk.
</p>
<p>
<b>License</b><br>
OpenKiosk is licensed under the terms of the <a href="http://www.gnu.org/licenses/gpl.html">GNU General Public License</a>.
Click on the link
or see the LICENSE file in the distribution to read it.
<br><br>
OpenKiosk is Copyright (C) 2024 by Rod Wright.
<br>
</p>
</body>
</html>

View File

@@ -6,30 +6,72 @@
# SPDX-License-Identifier: GPL-2.0 # SPDX-License-Identifier: GPL-2.0
OK_VERSION="1.0.2" APP_NAME="OpenKiosk"
APP_VERSION="1.1.0"
# Test for superuser
current_user=`whoami` function clean_exit() {
current_login=`who am i | awk '{print $1}'` # Re-enable unattended-upgrades
if [ "$current_user" != "root" ] if $restart_uu; then systemctl start unattended-upgrades; fi
then exit 0
echo "You must have root privileges to run this setup." }
echo "Try 'sudo ./kiosk-setup.sh'"
function abort_exit() {
# Re-enable unattended-upgrades
if $restart_uu; then systemctl start unattended-upgrades; fi
exit 1 exit 1
fi }
function privilege_check() {
# test for superuser rights
if [[ $EUID -ne 0 ]]; then
echo "This script must be run with superuser privileges. Try sudo $0"
exit 1
fi
}
function disable_unattended_upgrades() {
# Prevent unattended-upgrades from interfering
restart_uu=false
while systemctl status unattended-upgrades >/dev/null 2>&1
do
systemctl stop unattended-upgrades
sleep 5
restart_uu=true
done
}
# -------------- Begin execution --------------
privilege_check
echo "" echo ""
echo " Welcome to OpenKiosk $OK_VERSION" echo " Welcome to $APP_NAME $APP_VERSION installation"
echo "" echo ""
echo "" echo ""
echo "This script will configure a Debian based system to be a Kiosk Browser terminal." echo "This script will configure a Debian based system to be a kiosk browser terminal."
echo "" echo ""
echo "" echo ""
echo "To continue with the setup of OpenKiosk, press enter. Otherwise," continueok=false
echo -n "press ctrl-c to quit." while ! $continueok
read continueok do
echo "" read -p "Would you like to continue with OpenKiosk setup [Y/n]: " -r continueok
if [[ $continueok == "n" || $continueok == "N" ]]
then
exit 1
elif [[ $continueok == "y" || $continueok == "Y" || $continueok == "" ]]
then
continueok=true
echo "Continuing with OpenKiosk setup."
else
continueok=false
echo "Please answer Y (default) or N."
fi
done
echo "" echo ""
echo "Preparing for installation. Please wait..."
disable_unattended_upgrades
# Determine OS Release version # Determine OS Release version
echo -n "OS information: " echo -n "OS information: "
@@ -41,9 +83,9 @@ sleep 5
# Copy in the needed files # Copy in the needed files
echo "Copying files..." echo "Copying files..."
chmod +x usr/local/bin/* chmod +x usr/local/bin/*
cp -Rv etc/* /etc/ cp -Rvf etc/* /etc/
cp -v usr/local/bin/* /usr/local/bin cp -vf usr/local/bin/* /usr/local/bin
cp -v lib/systemd/system/getty@tty1.service /lib/systemd/system cp -vf lib/systemd/system/getty@tty1.service /lib/systemd/system
rm /lib/systemd/system/ctrl-alt-del.target rm /lib/systemd/system/ctrl-alt-del.target
ln -s /dev/null /lib/systemd/system/ctrl-alt-del.target ln -s /dev/null /lib/systemd/system/ctrl-alt-del.target
echo "...done." echo "...done."
@@ -51,9 +93,16 @@ echo "...done."
# Make sure OS is up to date # Make sure OS is up to date
echo "Updating Operating System..." echo "Updating Operating System..."
sleep 5 sleep 5
apt update && apt dist-upgrade -y if apt-get update && apt-get dist-upgrade -y
echo "...done." then
echo "" echo "...done."
echo ""
else
echo "A problem was encountered during installation."
echo "the command that failed was:"
echo " apt-get update && apt-get dist-upgrade -y"
abort_exit
fi
# Remove snap if installed # Remove snap if installed
if snap list >/dev/null 2>&1; then if snap list >/dev/null 2>&1; then
@@ -64,7 +113,7 @@ if snap list >/dev/null 2>&1; then
systemctl stop snapd systemctl stop snapd
systemctl disable snapd systemctl disable snapd
systemctl mask snapd systemctl mask snapd
apt purge snapd -y apt-get purge snapd -y
apt-mark hold snapd apt-mark hold snapd
rm -rf /home/*/snap/ rm -rf /home/*/snap/
rm -rf /root/snap/ rm -rf /root/snap/
@@ -72,8 +121,6 @@ if snap list >/dev/null 2>&1; then
rm -rf /var/snap rm -rf /var/snap
rm -rf /var/lib/snapd rm -rf /var/lib/snapd
echo "...done." echo "...done."
# Add the firefox deb repository since we won't be getting snap
add-apt-repository -y ppa:mozillateam/ppa
fi fi
# Install packages # Install packages
@@ -87,48 +134,81 @@ echo ""
# xorg server to start # xorg server to start
if cat /proc/cpuinfo|grep -q "Raspberry Pi 5" >/dev/null 2>&1 if cat /proc/cpuinfo|grep -q "Raspberry Pi 5" >/dev/null 2>&1
then then
apt install -y gldriver-test echo "Installing gl driver for Raspberry Pi 5..."
if apt-get install -y gldriver-test
then
echo "...done."
echo ""
else
echo "A problem was encountered during installation."
echo "the command that failed was:"
echo " apt-get install -y gldriver-test"
abort_exit
fi
fi fi
# If we are on a Raspberry Pi running Raspbian we use chromium-browser. # Install X server
# If we are on anything else, we use firefox. echo "Installing X server..."
if cat /etc/os-release|grep -q "Raspbian" >/dev/null 2>&1 if apt-get install -y --no-install-recommends xorg openbox xterm xpdf
then then
browser_pkg="chromium-browser" echo "...done."
ln -sf /etc/openkiosk.conf-chromium /etc/openkiosk.conf systemctl enable getty@tty1.service
echo ""
else else
browser_pkg="firefox" echo "A problem was encountered during installation."
ln -sf /etc/openkiosk.conf-firefox /etc/openkiosk.conf echo "the command that failed was:"
echo " apt-get install -y --no-install-recommends xorg openbox"
abort_exit
fi fi
# Install required packages # Try to install chromium-browser package, but if that fails, add
apt update # repository and install chromium package
apt install -y --no-install-recommends xorg openbox $browser_pkg while ! apt-get install -y chromium
apt install -y cups libcups2-dev cmake
systemctl enable getty@tty1.service
cd brlaser-master && cmake . && make && make install && cd ..
myhn=`hostname`
infotimer=10
echo ""
echo ""
echo ""
echo "The cups print server has been installed."
echo "After the kiosk is set up and working, you can use another network"
echo "computer to point a web browser to $myhn:631 to add a printer"
echo "of your choosing."
while [ $infotimer -gt 0 ]
do do
sleep 1 if add-apt-repository ppa:xtradeb/apps -y
((infotimer-=1)) then
echo "added chromium repository"
echo ""
else
echo "A problem was encountered during installation."
echo "the command that failed was:"
echo " apt-get install -y gldriver-test"
abort_exit
fi
apt-get update
done done
echo ""
# Download and install webmin # Check for webmin installation and prompt for install
echo "Installing webmin..." echo ""
skipwebmin="false" echo "Checking for webmin installation..."
curl -o setup-repos.sh https://raw.githubusercontent.com/webmin/webmin/master/setup-repos.sh echo ""
if [ $? -ne 0 ] if dpkg -l|grep webmin >/dev/null 2>&1
then then
echo ""
echo "webmin is installed. Continuing."
echo ""
else
echo "webmin doesn't seem to be installed."
echo "It is an optional package that enables system administration"
echo "using a friendly GUI. It is highly recommended, especially for"
echo "headless servers without any way to log in directly on the machine."
echo "Note that this has the potential to be a security risk, especially"
echo "if your passwords aren't sufficiently strong."
echo -n "Install it now? [Y/n]: "
read reqinstall
if [ "$reqinstall" = "N" -o "$reqinstall" = "n" ]
then
echo "Proceeding without installing webmin. System administration"
echo "will require login to the server either directly or via ssh."
else
echo ""
echo "Proceeding with webmin installation"
echo ""
sleep 3
echo "Installing webmin..."
skipwebmin="false"
if ! curl -o setup-repos.sh https://raw.githubusercontent.com/webmin/webmin/master/setup-repos.sh
then
echo "Warning: failed to download Webmin repo setup script." echo "Warning: failed to download Webmin repo setup script."
echo -n "Ignore and [c]ontinue or [A]bort? [c/A]: " echo -n "Ignore and [c]ontinue or [A]bort? [c/A]: "
read wmfailchoice read wmfailchoice
@@ -136,34 +216,100 @@ then
then then
skipwebmin="true" skipwebmin="true"
echo "Continuing without installing Webmin. You should investigate the failure" echo "Continuing without installing Webmin. You should investigate the failure"
echo "and install Webmin manually after the kiosk is set up if you would like" echo "and install Webmin manually after the server is set up if you would like"
echo "to be able to manage the kiosk from another computer with a GUI instead" echo "to be able to manage the server from another computer with a GUI instead"
echo "of through ssh only." echo "of through ssh only."
echo -n "Press enter to continue." echo -n "Press enter to continue."
read continueok read continueok
echo "" echo ""
else fi
echo "Aborting kiosk setup." fi
exit 1 if [ "$skipwebmin" = "false" ]
then
sh setup-repos.sh -f
apt-get install -y --install-recommends webmin
fi
echo "...done."
echo ""
echo "You can now access webmin using a web browser pointed to:"
echo "https://$HOSTNAME:10000"
echo "Unless you have obtained valid ssl certificates, your server is"
echo "using self-signed certs. This is not necessarily a problem, but"
echo "your browser will complain. You can tell the browser to accept the"
echo "self signed certificates and the traffic will still be encrypted,"
echo "however you may be vulnerable to man-in-the-middle attacks. You can"
echo "get free valid certificates through LetsEncrypt."
echo "See http://letsencrypt.org for more information."
echo ""
echo -n "Press enter to continue."
read continueok
echo ""
echo "Finished with webmin installation"
echo ""
sleep 3
fi fi
fi fi
if [ "$skipwebmin" = "false" ]
# Prompt whether to install print server
echo ""
echo "Checking for cups print server and driver installation..."
echo ""
if dpkg -l|grep cups-common >/dev/null 2>&1 && \
test -f "/usr/share/cups/drv/brlaser.drv" >/dev/null 2>&1
then then
sh setup-repos.sh -f echo ""
apt install -y --install-recommends webmin echo "cups is installed. Continuing."
echo ""
else
echo "The cups print server or driver doesn't seem to be installed."
echo "If this will be an interactive kiosk and you would like to"
echo "be able to print from it, cups will need to be installed."
read -p "Install it now? [Y/n]: " -r reqinstall
if [ "$reqinstall" = "N" -o "$reqinstall" = "n" ]
then
echo "Proceeding without installing cups."
else
echo ""
echo "Proceeding with cups installation"
echo ""
sleep 3
echo "Installing cups print server and drivers..."
apt-get install -y cups libcups2-dev cmake
cd brlaser-master && cmake . && make && make install && cd ..
chmod -R a+w brlaser-master
usermod -G lpadmin $(who am i|cut -d" " -f1)
myhn=`hostname`
echo ""
echo ""
echo ""
echo "The cups print server has been installed."
echo "After the kiosk is set up and working, edit /etc/openkiosk.conf"
echo "and set the TGT_URL parameter to:"
echo " https://localhost:631"
echo "to add or manage printers via the kiosk browser."
echo "When you are finished, change it back to your normal URL."
echo "Note that the kiosk browser will, by default, print to the server"
echo "default printer."
echo ""
echo -n "Press enter to continue."
read continueok
echo ""
echo "Finished with cups print server installation"
echo ""
sleep 3
fi
fi fi
echo "...done."
# Install user config # Install user config
echo "" echo ""
echo "Creating default user..." echo "Creating kiosk user..."
cloneuser `who am i | awk '{print $1}'` customer cloneuser.sh `who am i | awk '{print $1}'` kioskuser
mkdir -p /home/customer/.config/openbox mkdir -p /home/kioskuser/.config/openbox
cp home/customer/.profile /home/customer cp -Rv home/kioskuser /home/
cp home/customer/.config/openbox/rc.xml /home/customer/.config/openbox cp home/kioskuser/.profile /home/kioskuser
cp home/customer/openkiosk_mozilla_profile.tar.gz /home/customer cp home/kioskuser/.config/openbox/rc.xml /home/kioskuser/.config/openbox
chown customer:customer /home/customer/openkiosk_mozilla_profile.tar.gz chown -R kioskuser:kioskuser /home/kioskuser/.config /home/kioskuser/.profile
chown -R customer:customer /home/customer/.config /home/customer/.profile
echo "...done." echo "...done."
echo "" echo ""
@@ -171,24 +317,42 @@ echo ""
echo "" echo ""
echo "This web browser based kiosk will need to know the site you would" echo "This web browser based kiosk will need to know the site you would"
echo "like to load. This can be a normal website or a file to be displayed" echo "like to load. This can be a normal website or a file to be displayed"
echo "in the browser, but must be available as a web URL." echo "in the browser, but must be available as a web URL (http://something)."
echo "" echo ""
echo "Note that in kiosk mode, your normal navigation buttons and mouse" echo "Note that in kiosk mode, your normal navigation buttons and mouse"
echo "right-click menus are not available, so you will have no way to go" echo "right-click menus are not available, so you will have no way to go"
echo "back or forward in a page unless the page itself provides that" echo "back or forward in a page unless the page itself provides that"
echo "capability." echo "capability."
url_ok=false url_ok=false
server_url="https://localhost:10000" server_url="file:/home/kioskuser/openkiosk_welcome.html"
while ! $url_ok while ! $url_ok
do do
echo "" echo ""
echo "Please enter complete URL." echo "Please enter complete URL. Valid formats are:"
echo -n "[https://localhost:10000] :" echo "\"http://somesite.com/somepage\""
read server_url echo "\"file:/path/to/file.name\""
echo ""
read -p "[file:/home/kioskuser/openkiosk_welcome.html] :" -r server_url
if [[ $server_url == "" ]] if [[ $server_url == "" ]]
then then
server_url="https://localhost:10000" server_url="file:/home/kioskuser/openkiosk_welcome.html"
fi fi
if [[ $server_url == "test" ]]
then
url_ok=true
elif echo "$server_url" | grep -q '^file:'
then
filepath=$(echo "$server_url"|cut -d":" -f2-)
if [ ! -f "$filepath" ]
then
echo ""
echo "There was an error reading the file you entered. The URL must"
echo "be a complete valid path specification of the format:"
echo "\"file:/path/to/file.name\" on the kiosk's filesystem."
else
url_ok=true
fi
else
if ! `wget --no-check-certificate -q -o /dev/null -O /dev/null $server_url` if ! `wget --no-check-certificate -q -o /dev/null -O /dev/null $server_url`
then then
echo "" echo ""
@@ -200,9 +364,9 @@ do
else else
url_ok=true url_ok=true
fi fi
fi
done done
sed -i 's,'TGT_URL=.*','TGT_URL="\"$server_url\""',' /etc/openkiosk.conf-firefox sed -i 's,'TGT_URL=.*','TGT_URL="\"$server_url\""',' /etc/openkiosk.conf
sed -i 's,'TGT_URL=.*','TGT_URL="\"$server_url\""',' /etc/openkiosk.conf-chromium
echo "" echo ""
type_choice="none" type_choice="none"
while [ "$type_choice" = "none" ] while [ "$type_choice" = "none" ]
@@ -211,7 +375,7 @@ do
echo -n "[I]nteractive or [D]isplay-only? [I] :" echo -n "[I]nteractive or [D]isplay-only? [I] :"
read kiosk_type read kiosk_type
echo "" echo ""
if [ "$kiosk_type" = "D" -o "$kiosk_type" = "d" ] if [[ $kiosk_type == "D" || $kiosk_type == "d" ]]
then then
echo "Configuring for display-only kiosk." echo "Configuring for display-only kiosk."
echo "How often would you like to check for changes to the page being" echo "How often would you like to check for changes to the page being"
@@ -220,14 +384,12 @@ do
echo -n "Seconds between checks? [60] :" echo -n "Seconds between checks? [60] :"
read poll_interval read poll_interval
echo "" echo ""
if [ "$poll_interval" = "" ]; then poll_interval=60; fi if [[ $poll_interval == "" ]]; then poll_interval=60; fi
sed -i 's,'POLL_INTERVAL=.*','POLL_INTERVAL="\"$poll_interval\""',' /etc/openkiosk.conf-firefox sed -i 's,'POLL_INTERVAL=.*','POLL_INTERVAL="\"$poll_interval\""',' /etc/openkiosk.conf
sed -i 's,'POLL_INTERVAL=.*','POLL_INTERVAL="\"$poll_interval\""',' /etc/openkiosk.conf-chromium
echo "Disabling screen blanking." echo "Disabling screen blanking."
sed -i 's,'INHIBIT_BLANK=.*','INHIBIT_BLANK="\"1\""',' /etc/openkiosk.conf-firefox sed -i 's,'INHIBIT_BLANK=.*','INHIBIT_BLANK="\"1\""',' /etc/openkiosk.conf
sed -i 's,'INHIBIT_BLANK=.*','INHIBIT_BLANK="\"1\""',' /etc/openkiosk.conf-chromium
type_choice="D" type_choice="D"
elif [ "$kiosk_type" = "I" -o "$kiosk_type" = "i" ] elif [[ $kiosk_type == "I" || $kiosk_type = "i" || $kiosk_type == "" ]]
then then
echo "Configuring for interactive kiosk." echo "Configuring for interactive kiosk."
type_choice="I" type_choice="I"
@@ -239,11 +401,11 @@ echo ""
echo "Kiosk configuration is now complete. " echo "Kiosk configuration is now complete. "
echo "" echo ""
echo "The system must be rebooted for the configuration to take effect." echo "The system must be rebooted for the configuration to take effect."
echo -n "Enter R to reboot now, or hit enter to return to shell. " echo ""
read rebootok read -p "Would you like to reboot now? [Y/n]: " -r rebootok
if [ "$rebootok" = "R" -o "$rebootok" = "r" ] if [[ $rebootok == "Y" || $rebootok == "y" || $rebootok == "" ]]
then then
reboot reboot
else else
exit 0 clean_exit
fi fi

View File

@@ -31,7 +31,7 @@ ConditionPathExists=/dev/tty0
[Service] [Service]
# the VT is cleared by TTYVTDisallocate # the VT is cleared by TTYVTDisallocate
ExecStart=-/sbin/agetty -a customer --noclear %I $TERM ExecStart=-/sbin/agetty -a kioskuser --noclear %I $TERM
Type=idle Type=idle
Restart=always Restart=always
RestartSec=0 RestartSec=0

View File

@@ -1,8 +1,7 @@
#!/bin/bash #!/bin/bash
# kiosk_cleanup.sh # kiosk_cleanup.sh
rm -rf /home/customer/.{config,cache}/chromium/ rm -rf /home/kioskuser/.{config,cache}/chromium/
rm -rf /home/customer/.cache/mozilla rm -rf /dev/shm/target.pdf
rm -rf /home/customer/.mozilla pkill xmessage
tar -C /home/customer -xf /home/customer/openkiosk_mozilla_profile.tar.gz
chown -R customer:customer /home/customer/.mozilla

View File

@@ -3,18 +3,46 @@
source /etc/openkiosk.conf source /etc/openkiosk.conf
function set_commands() {
source /etc/openkiosk.conf
if [[ $TGT_URL == "test" ]]
then
# Enter test mode
APP_CMD="xterm"
ALIVE_STRING="xterm"
KILL_CMD="pkill xterm"
CLEANUP_CMD="sleep 1"
debuglog "Entering test mode"
elif echo "$TGT_URL" | grep -q '\.pdf$'
then
# The URL is a pdf file
APP_CMD="viewpdf.sh $TGT_URL"
ALIVE_STRING="xpdf"
KILL_CMD="pkill xpdf"
CLEANUP_CMD="kiosk_cleanup.sh"
debuglog "URL is a pdf file. Command is $PDF_APP_CMD"
else
# Assume the URL returns HTML
APP_CMD="viewhtml.sh $TGT_URL"
ALIVE_STRING="chromium"
KILL_CMD="pkill chromium"
CLEANUP_CMD="kiosk_cleanup.sh"
debuglog "URL is an HTML file. Command is $HTML_APP_CMD"
fi
}
function check_conf() { function check_conf() {
debuglog "Checking configuration file for changes." debuglog "Checking configuration file for changes."
new_conf_md5=`md5sum /etc/openkiosk.conf|cut -d " " -f1` new_conf_md5=`md5sum /etc/openkiosk.conf|cut -d " " -f1`
debuglog "New config file checksum: $new_conf_md5" debuglog "New config file checksum: $new_conf_md5"
curr_conf_md5=`cat /home/customer/curr_conf_md5.txt` curr_conf_md5=`cat /dev/shm/curr_conf_md5.txt`
debuglog "Current config file checksum: $curr_conf_md5" debuglog "Current config file checksum: $curr_conf_md5"
diff <(echo $new_conf_md5) <(echo $curr_conf_md5) >/dev/null 2>&1 diff <(echo $new_conf_md5) <(echo $curr_conf_md5) >/dev/null 2>&1
if [ "$?" -eq "1" ] if [ "$?" -eq "1" ]
then then
debuglog "Config file has changed!" debuglog "Config file has changed!"
echo $new_conf_md5 > /home/customer/curr_conf_md5.txt echo $new_conf_md5 > /dev/shm/curr_conf_md5.txt
debuglog "Killing browser" debuglog "Killing application"
$KILL_CMD $KILL_CMD
$CLEANUP_CMD $CLEANUP_CMD
return 1 return 1
@@ -25,16 +53,29 @@ function check_conf() {
function check_url() { function check_url() {
debuglog "Checking URL for changes" debuglog "Checking URL for changes"
if [[ $TGT_URL == "test" ]]
then
return 0
fi
if echo "$TGT_URL"|grep -q '^http'
then
new_url_md5=`wget -q -o /dev/null -O - $TGT_URL|md5sum|cut -d " " -f1` new_url_md5=`wget -q -o /dev/null -O - $TGT_URL|md5sum|cut -d " " -f1`
elif echo "$TGT_URL"|grep -q '^file'
then
filepath=$(echo "$TGT_URL"|cut -d":" -f2-)
new_url_md5=`md5sum $filepath|cut -d " " -f1`
else
new_url_md5=""
fi
debuglog "New URL checksum: $new_url_md5" debuglog "New URL checksum: $new_url_md5"
curr_url_md5=`cat /home/customer/curr_url_md5.txt` curr_url_md5=`cat /dev/shm/curr_url_md5.txt`
debuglog "Current URL checksum: $curr_url_md5" debuglog "Current URL checksum: $curr_url_md5"
diff <(echo $new_url_md5) <(echo $curr_url_md5) >/dev/null 2>&1 diff <(echo $new_url_md5) <(echo $curr_url_md5) >/dev/null 2>&1
if [ "$?" -eq "1" ] if [ "$?" -eq "1" ]
then then
debuglog "URL has changed!" debuglog "URL has changed!"
echo $new_url_md5>/home/customer/curr_url_md5.txt echo $new_url_md5>/dev/shm/curr_url_md5.txt
debuglog "Killing browser" debuglog "Killing application"
$KILL_CMD $KILL_CMD
$CLEANUP_CMD $CLEANUP_CMD
return 1 return 1
@@ -46,11 +87,11 @@ function check_url() {
function debuglog() { function debuglog() {
if [ "$DEBUG" -eq "1" ] if [ "$DEBUG" -eq "1" ]
then then
if [ ! -e "/home/customer/startkiosk.log" ] if [ ! -e "/home/kioskuser/startkiosk.log" ]
then then
echo "startkiosk log started : "`date +%Y-%m-%d %H:%M:%S` > /home/customer/startkiosk.log echo "startkiosk log started : "`date +%Y-%m-%d %H:%M:%S` > /home/kioskuser/startkiosk.log
fi fi
echo `date +%H:%M:%S` "$1">>/home/customer/startkiosk.log echo `date +%H:%M:%S` "$1">>/home/kioskuser/startkiosk.log
fi fi
} }
@@ -68,24 +109,38 @@ function set_blank_params() {
function set_rot_params() { function set_rot_params() {
output_name=`xrandr --listactivemonitors|grep 0:|rev|cut -d " " -f1|rev` output_name=`xrandr --listactivemonitors|grep 0:|rev|cut -d " " -f1|rev`
xrandr --output $output_name --rotate "normal"
sleep 1
xrandr --output $output_name --rotate $ROTATION xrandr --output $output_name --rotate $ROTATION
} }
set_commands
openbox-session & openbox-session &
sleep 1 sleep 1
set_blank_params set_blank_params
$KILL_CMD pkill xpdf
$CLEANUP_CMD pkill chromium
pkill xterm
kiosk_cleanup.sh
# start application # start application
$APP_CMD &
$APP_CMD &
sleep 3 sleep 3
new_url_md5=`wget -q -o /dev/null -O - $TGT_URL|md5sum|cut -d " " -f1` if echo "$TGT_URL"|grep -q '^http'
echo $new_url_md5>/home/customer/curr_url_md5.txt then
new_url_md5=`wget -q -o /dev/null -O - $TGT_URL|md5sum|cut -d " " -f1`
elif echo "$TGT_URL"|grep -q '^file'
then
filepath=$(echo "$TGT_URL"|cut -d":" -f2-)
new_url_md5=`md5sum $filepath|cut -d " " -f1`
else
new_url_md5=""
fi
echo $new_url_md5>/dev/shm/curr_url_md5.txt
new_conf_md5=`md5sum /etc/openkiosk.conf|cut -d " " -f1` new_conf_md5=`md5sum /etc/openkiosk.conf|cut -d " " -f1`
echo $new_conf_md5 > /home/customer/curr_conf_md5.txt echo $new_conf_md5 > /dev/shm/curr_conf_md5.txt
while true while true
do do
@@ -98,7 +153,7 @@ source /etc/openkiosk.conf
if ! pgrep $ALIVE_STRING if ! pgrep $ALIVE_STRING
then then
# relaunch application if it terminates # relaunch application if it terminates
debuglog "Restarting browser" debuglog "Restarting with command $APP_CMD"
$APP_CMD & $APP_CMD &
fi fi
@@ -106,11 +161,21 @@ if [ "$POLL_INTERVAL" -eq "0" ]
then then
sleep 1 sleep 1
debuglog "Polling not enabled" debuglog "Polling not enabled"
if ! check_conf; then set_blank_params;set_rot_params;fi if ! check_conf
then
set_blank_params
set_rot_params
set_commands
fi
else else
sleep $POLL_INTERVAL sleep $POLL_INTERVAL
debuglog "Polling enabled" debuglog "Polling enabled"
if ! check_conf; then set_blank_params;set_rot_params;fi if ! check_conf
then
set_blank_params
set_rot_params
set_commands
fi
check_url check_url
fi fi
done done

19
usr/local/bin/viewhtml.sh Executable file
View File

@@ -0,0 +1,19 @@
#!/bin/bash
# viewhtml.sh
if [ "$1" = "" ]
then
"You must supply a URL as an argument"
exit 1
fi
source /etc/openkiosk.conf
if ! chromium --test-type --ignore-certificate-errors --kiosk \
--no-first-run --check-for-update-interval=1 --simulate-upgrade \
--incognito $1
then
kiosk_cleanup.sh
xmessage -buttons "Ok:1" -center "Failed to retrieve web page."
exit 1
fi

26
usr/local/bin/viewpdf.sh Executable file
View File

@@ -0,0 +1,26 @@
#!/bin/bash
# viewpdf.sh
if [ "$1" = "" ]
then
"You must supply a URL as an argument"
exit 1
fi
source /etc/openkiosk.conf
if echo "$1" | grep -q '^file:'
then
filepath=$(echo "$server_url"|cut -d"/" -f2-)
xpdf -fullscreen -cont -z width $filepath
else
if ! wget -q -O /dev/shm/target.pdf $1
then
kiosk_cleanup.sh
xmessage -buttons "Ok:1" -center "Failed to retrieve pdf file."
exit 1
else
xpdf -fullscreen -cont -z width /dev/shm/target.pdf
fi
fi